<template>
  <div v-if="isHaveData && !allowTheme" class="w-full px-4 py-4 bg-background2">
    <div
      v-for="(item, index) in tableData"
      :key="index"
      class="relative w-full mb-4 rounded-lg bg-background1 last:mb-0"
    >
      <div :class="`${item.StatusStringColorForDisplayMobile} status-box`">
        <h4 class="font-bold text-white">{{ item.StatusStringForDisplay }}</h4>
      </div>
      <div class="flex flex-col px-4 py-3">
        <h3 class="flex mb-2 font-bold fc-hint">
          <span class="mr-5">{{ $t("request") }}</span>
          <span>{{ item.RequestAmountForDisplay }}</span>
        </h3>
        <div>
          <span>{{ item.RequestDateForDisplayMobile }}</span>
        </div>
      </div>
      <div
        v-if="item.StatusString.toLowerCase() !== 'waiting'"
        class="flex flex-col px-4 py-3 border-t-2 border-dashed border-top-style"
      >
        <h3 class="flex mb-2 font-bold fc-hint">
          <span class="mr-5">{{ $t("approved") }}</span>
          <span>{{ item.ApprovedAmountForDisplay }}</span>
        </h3>
        <div class="flex flex-col">
          <span>{{ item.ModifiedDateForDisplayMobile }}</span>
          <div>
            <span class="mr-3">{{ $t("remark") }}:</span>
            <span>{{ item.Remark }}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
  <div v-else-if="allowTheme" class="referral-history">
    <div
      class="w-full h-[15vh] flex justify-center items-center bg-background2"
    >
      <div class="flex flex-col items-center justify-center">
        <h1>{{ referralForDisplay }}</h1>
        <h6 class="flex items-center justify-center w-full">
          <span class="pr-1">{{ $t("you've_been_reward") }}</span>
          <img v-if="themeColor.Text === 'bk8'" :src="getAssetImage('assets/referral/infoicon.png')" alt="info_icon" loading="lazy">
          <el-tooltip>
            <template #content>
              <div class="flex flex-col">
                <div>{{ $t("referral_count") }} : {{ referralCount }}</div>
                <div>{{ $t("reward") }} : {{ totalRewardForDisplay }}</div>
                <div>{{ $t("rebate") }} : {{ rebet }}</div>
              </div>
            </template>
            <font-awesome-icon icon="circle-info" />
          </el-tooltip>
        </h6>
      </div>
    </div>
    <div class="bg-background1 w-full h-[125px] p-2 flex flex-col items-center">
      <div
        class="flex flex-col justify-center items-start gap-4 h-[37px] mt-[13px]"
      >
        <div class="flex flex-row items-center justify-center px-4">
          <div class="flex flex-col items-center p-0 gap-1 w-[140px]">
            <h5>{{ $t("redeemable") }}</h5>
            <h2 class="fc-primary text-[16px] font-bold">
              {{ redeemableForDisplay }}
            </h2>
          </div>
          <div class="w-[30px] h-[30px]">
            <img
              :src="
                getAssetImage(
                  'assets/theme/new_black_theme/referral/redeem-arrow.png'
                )
              "
              alt=""
            />
          </div>
          <div class="flex flex-col items-center p-0 gap-1 w-[140px]">
            <h5>{{ $t("redeemed") }}</h5>
            <h2 class="fc-secondary opacity-30 text-[16px] font-bold">
              {{ redeemedForDisplay }}
            </h2>
          </div>
        </div>
      </div>
      <div class="flex justify-center">
        <div class="redeem-btn">
          <el-button type="primary" plain round @click="onRedeemNow">
            {{ $t("redeem_now") }}
          </el-button>
        </div>
        <el-dialog
          v-model="dialogVisible"
          custom-class="redeem-dialog"
          width="95%"
          destroy-on-close
          :show-close="false"
        >
          <template #title>
            <div class="redeem-header-dialog">
              <span class="h-4 text-sm font-bold leading-4">
                {{ $t("redeem") }}
              </span>
              <div class="w-[20px] h-[20px]" @click="onCloseDialog">
                <font-awesome-icon
                  class="w-[20px] h-[20px] x-mark cursor-pointer"
                  icon="xmark"
                />
              </div>
            </div>
          </template>
          <referral-modal v-if="!isLoading" />
        </el-dialog>
      </div>
    </div>
    <div
      v-if="isHaveData"
      class="w-full px-4 py-4 flex flex-col h-[calc(100vh-13vh-3.4vw-170px-12.8vw)] referral-history__table"
    >
      <span
        class="font-bold text-[16px] leading-[19px] pl-2 fc-text2 referral-history__table-title"
      >
        {{ $t("history") }}
      </span>
      <el-table
        :data="tableData"
        border
        style="width: 100%"
        height="100%"
        header-cell-class-name="leading-1"
      >
        <el-table-column
          header-align="center"
          align="left"
          prop="RefNo"
          :label="$t('Amount Request/Approved')"
          width="130"
        >
          <template #default="scope">
            <div class="flex flex-row items-center justify-center gap-1 px-1">
              <span class="font-normal text-xs leading-[14px] text-center bk8-text1">
                {{ scope.row.RequestAmountForDisplay }}
              </span>
              <span>/</span>
              <span
                class="font-normal text-xs leading-[14px] text-center fc-primary  bk8-text2"
              >
                {{ scope.row.ApprovedAmountForDisplay }}
              </span>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          header-align="center"
          align="left"
          prop="RefNo"
          :label="$t('Date Request/Approved')"
          width="130"
        >
          <template #default="scope">
            <div class="flex flex-col items-center gap-[2px] bk8-date">
              <span class="font-normal text-xs leading-[14px] text-center ">
                {{ scope.row.RequestDateForDisplay }}
              </span>
              <span class="font-normal text-xs leading-[14px] text-center">
                {{ scope.row.ModifiedDateForDisplay }}
              </span>
            </div>
          </template>
        </el-table-column>
        <el-table-column
          header-align="center"
          align="left"
          prop="RefNo"
          :label="$t('status')"
        >
          <template #default="scope">
            <div
              class="flex flex-row items-center justify-center px-1 gap-[10px]"
            >
              <span
                class="font-normal text-xs leading-[14px] text-center"
                :class="scope.row.StatusStringColorForDisplay"
              >
                {{ scope.row.StatusStringForDisplay }}
              </span>
            </div>
          </template>
        </el-table-column>
      </el-table>
    </div>
    <div v-else>
      <h1 class="font-bold text-[16px] leading-[19px] px-4 py-4 fc-text2">
        {{ $t("history") }}
      </h1>
      <lazy-utils-not-found />
    </div>
  </div>
  <div v-else>
    <lazy-utils-not-found />
  </div>
</template>

<script lang="ts">
import { computed, defineComponent } from "vue";
import { store } from "@/store";

export default defineComponent({
  setup() {
    const { tableData, isLoading } = useReferralHistory();
    const isHaveData = computed(() => tableData.value.length > 0);
    const { themeColor } = themePropertyHelper;
    const allowTheme = computed(
      () =>
        store.state.selectedThemeName === "main" ||
        store.state.selectedThemeName === "black"
    );
    const { getAssetImage } = commonHelper;
    const {
      referralForDisplay,
      onRedeemNow,
      rebet,
      referralCount,
      totalForDisplay,
      totalRewardForDisplay,
      redeemedForDisplay,
      redeemableForDisplay,
      dialogVisible,
    } = useReferralComponent();
    const onCloseDialog = () => {
      dialogVisible.value = false;
    };
    return {
      tableData,
      isLoading,
      isHaveData,
      allowTheme,
      getAssetImage,
      referralForDisplay,
      onRedeemNow,
      rebet,
      referralCount,
      totalForDisplay,
      totalRewardForDisplay,
      redeemedForDisplay,
      redeemableForDisplay,
      dialogVisible,
      onCloseDialog,
      themeColor
    };
  },
});
</script>
<style scoped>
:deep(.el-table__body-wrapper) {
  position: relative;
  overflow: scroll;
  height: calc(100vh - 115%);
}
:deep(.el-table th.el-table__cell) {
  background: var(--background4);
  color: var(--text2);
}
:deep(.el-table) {
  border-radius: 10px;
  --el-table-tr-bg-color: var(--background2);
  --el-table-bg-color: white;
}
:deep(.redeem-btn button.el-button) {
  width: 152px;
  height: 40px;
  margin-left: 0;
  margin-top: 14px;
  background-color: transparent;
}
:deep(.redeem-btn.el-button span) {
  @apply text-sm font-bold leading-4;
  color: var(--primary);
}
</style>
<style lang="postcss">
.status-box {
  @apply absolute mt-4 right-0 w-[84px] h-fit;
  @apply flex justify-center items-center rounded-l-xl;
}
.border-top-style {
  border-color: rgba(var(--text), 0.7);
}
.box-show-data {
  @apply border-r-2 flex flex-col items-center my-4 py-3 px-8;
}
.box-show-data:last-child {
  @apply border-r-0;
}
:deep(.el-dialog__title) {
  font-weight: bold;
  font-size: 20px;
  color: var(--text);
}
.redeem-dialog .el-form-item--default {
  margin-bottom: 4px;
}
.redeem-dialog {
  @apply overflow-hidden;
  --el-dialog-bg-color: var(--background2);
  --el-dialog-width: 85% !important;
  --el-dialog-padding-primary: none;
  --el-dialog-border-radius: 0.5rem;
  --el-dialog-margin-top: 20vh !important;
  border: 1px solid var(--border);
  height: 260px !important;
}
.redeem-dialog .el-dialog__header {
  margin-right: 0;
  padding-bottom: 0;
}
.redeem-header-dialog {
  @apply flex flex-row justify-between items-center py-2 px-4 h-9;
  background: var(--background1);
}
[theme-color="bk8"] .redeem-btn .el-button {
  background-color: var(--background1) !important;
  color: var(--primary) !important;
}
[theme-color="bk8"] .redeem-header-dialog {
  padding-left: 12px;
}
[theme-color="bk8"] .el-table th.el-table__cell {
  color: var(--text4);
}
[theme-color="bk8"] .el-table .cell {
  line-height: 14.06px;
  font-weight: 400;
}
[theme-color="bk8"] .fc-text2 {
  color: var(--text);
  padding-bottom: 8px;
}
[theme-color="bk8"] .bk8-text1 {
  color: var(--text);
  font-size: 12px;
}
[theme-color="bk8"] .bk8-text2 {
  color: var(--success);
  font-size: 12px;
}
[theme-color="bk8"] .bk8-date {
  color: var(--text);
  font-size: 12px;
}
</style>
